package org.foxarmy.barcodescannerforemployees.activities

import android.content.Intent
import android.os.Bundle
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import org.foxarmy.barcodescannerforemployees.Net
import org.foxarmy.barcodescannerforemployees.R
import org.foxarmy.barcodescannerforemployees.databinding.ActivityAccountSettingsBinding

class AccountSettingsActivity : AppCompatActivity() {

    private lateinit var binding: ActivityAccountSettingsBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityAccountSettingsBinding.inflate(layoutInflater)

        setContentView(binding.root)

        val sharedPreferences = org.foxarmy.barcodescannerforemployees.getPreferences(this)

        val net = Net()

        net.server = sharedPreferences.getString("server", "bsfe.foxarmy.org")!!
        net.language = sharedPreferences.getString("language", "")!!
        net.token = sharedPreferences.getString("token", "")!!

        binding.saveUsernameButton.setOnClickListener {
            net.changeUsername(binding.newUsernameTextEdit.text.toString(), { response ->
                if (response.code == 200) {
                    runOnUiThread {
                        Toast.makeText(this, getString(R.string.username_changed), Toast.LENGTH_LONG).show()
                        val intent = Intent(this, LoginActivity::class.java)
                        startActivity(intent)
                        finish()
                    }
                } else {
                    runOnUiThread {
                        Toast.makeText(this, response.body!!.string(), Toast.LENGTH_LONG).show()
                    }
                }
            })

        }

        binding.savePasswordButton.setOnClickListener {
            net.changePassword(binding.newPasswordTextEdit.text.toString(), { response ->
                if (response.code == 200) {
                    runOnUiThread {
                        Toast.makeText(this, getString(R.string.password_changed), Toast.LENGTH_LONG).show()
                        val intent = Intent(this, LoginActivity::class.java)
                        startActivity(intent)
                        finish()
                    }
                } else {
                    runOnUiThread {
                        Toast.makeText(this, response.body!!.string(), Toast.LENGTH_LONG).show()
                    }
                }
            })

        }
    }
}