package org.foxarmy.barcodescannerforemployees.activities

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.widget.LinearLayout
import androidx.appcompat.app.AppCompatActivity
import org.foxarmy.barcodescannerforemployees.Net
import org.foxarmy.barcodescannerforemployees.R
import org.foxarmy.barcodescannerforemployees.databinding.ActivityMyGroupsBinding
import org.foxarmy.barcodescannerforemployees.parseIntArray
import org.foxarmy.barcodescannerforemployees.views.GroupView

class MyGroupsActivity : AppCompatActivity(){
    private lateinit var binding: ActivityMyGroupsBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityMyGroupsBinding.inflate(layoutInflater)
        setContentView(binding.root)

        val sharedPreferences = org.foxarmy.barcodescannerforemployees.getPreferences(this)

        val net = Net()

        net.token = sharedPreferences.getString("token", "")!!
        net.server = sharedPreferences.getString("server", "")!!
        net.language = sharedPreferences.getString("language", "en-US")!!

        net.getMyGroups { response ->
            val groups = parseIntArray(response.body!!.string())


            val container = findViewById<LinearLayout>(R.id.groupsLayout)

            for (group in groups) {
                net.getGroupName(group, {response ->
                    val groupView = GroupView(this, this as Context, response, group)

                    runOnUiThread {
                        container.addView(groupView)
                    }
                })
            }

            binding.newGroup.setOnClickListener {
                runOnUiThread {
                    val intent = Intent(this, GroupActivity::class.java)
                    startActivity(intent)
                }
            }
        }
    }
}