package org.foxarmy.barcodescannerforemployees.dataclasses

import android.os.Parcel
import android.os.Parcelable
import org.foxarmy.barcodescannerforemployees.md5
import org.json.JSONObject

class Category() : Parcelable {
    var id = 0
    var name = ""


    constructor(id: Int, name: String) : this() {
        this.id = id
        this.name = name
    }

    constructor(parcel: Parcel) : this() {
        id = parcel.readInt()
        name = parcel.readString()!!
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(id)
        parcel.writeString(name)
    }

    override fun describeContents(): Int {
        return 0
    }

    fun calculateHash(): String {
        return "$id:$name".md5()
    }

    companion object CREATOR : Parcelable.Creator<Category> {
        override fun createFromParcel(parcel: Parcel): Category {
            return Category(parcel)
        }

        override fun newArray(size: Int): Array<Category?> {
            return arrayOfNulls(size)
        }

        fun createFromJSON(json: JSONObject): Category {
            return Category(
                json["local_id"].toString().toInt(),
                json["name"].toString()
            )
        }
    }
}