package org.foxarmy.barcodescannerforemployees.views

import android.app.Activity
import android.content.Context
import android.content.SharedPreferences
import android.view.LayoutInflater
import android.widget.LinearLayout
import android.widget.TextView
import androidx.core.content.ContextCompat
import org.foxarmy.barcodescannerforemployees.R
import org.foxarmy.barcodescannerforemployees.activities.ExpiryCalendarActivity
import org.foxarmy.barcodescannerforemployees.database.DBStorageController
import org.foxarmy.barcodescannerforemployees.database.ProductDAO
import org.foxarmy.barcodescannerforemployees.getPreferences
import java.text.SimpleDateFormat

class ExpiryGroupView : LinearLayout {

    private var representingDate: Long? = null

    private var sharedPreferences: SharedPreferences
    private var productDAO: ProductDAO

    constructor(activity: Activity, context: Context, representingDate: Long) : super(context) {

        sharedPreferences = getPreferences(context)

        val dbHelper = DBStorageController(context, sharedPreferences.getString("currentGroup", "database")!!)
        productDAO = ProductDAO(dbHelper)

        val inflater: LayoutInflater = activity.layoutInflater
        inflater.inflate(R.layout.expiry_group_view, this)

        this.representingDate = representingDate

        this.background = ContextCompat.getDrawable(context,R.drawable.outline)

        val amount = productDAO.findAmountOfProductsWithExpiryDate(representingDate)

        findViewById<TextView>(R.id.representingDateTextView).text = SimpleDateFormat("dd.MM.yyyy").format(representingDate * 1000)
        findViewById<TextView>(R.id.amountTextView).text = amount.toString()

        setOnClickListener {
            (activity as ExpiryCalendarActivity).displayDate(representingDate)
        }
    }
}